package com.usky.fire.service;

import com.usky.common.core.bean.CommonPage;
import com.usky.common.mybatis.core.CrudService;
import com.usky.fire.domain.DemWaterSource;

import java.util.Map;

/**
 * <p>
 * 水源信息表 服务类
 * </p>
 *
 * @author JCB
 * @since 2022-10-24
 */
public interface DemWaterSourceService extends CrudService<DemWaterSource> {

    /**
     * 消防水源管理-列表
     *
     * @param waterName 水源名称
     * @param id        主键ID
     * @param pageNum   当前页
     * @param pageSize  每页条数
     * @return
     */
    CommonPage<Map<String, Object>> waterSourceList(String waterName, Integer id, Integer pageNum, Integer pageSize);

    /**
     * 消防水源管理-修改
     *
     * @param demWaterSource
     */
    void updateWaterSource(DemWaterSource demWaterSource);

    /**
     * 消防水源管理-删除
     *
     * @param id 主键ID
     */
    void delWaterSource(Integer id);
}
